// bmx2wav.class.nut

// -- ParameterColumn
class ParameterColumn extends Column {
  constructor() {
    base.constructor( "ϊݒ" );
  }

  function display_cell( entry ) {
    local parameter = entry.get_individual_parameter();

    if ( parameter ) {
      return parameter.name + "iʁj"
    }
    else {
      return Main.get_common_parameter().name + "iʁj"
    }
  }

  function compare( x, y ) {
    return ( x.get_individual_parameter() == null ) <=> ( y.get_individual_parameter() == null );
  }
}


// -- o̓ev[g֌W -----
Main.translate_template_path_by_parameter <- function ( parameter, bms_data ) {
  return Main.translate_template_path( parameter.output_file_template,
                                       parameter.input_file_path,
                                       parameter.output_as_ogg,
                                       bms_data );
}

Main.Converter.get_translated_template_path <- function () {
  return Main.translate_template_path_by_parameter( this.parameter, this.bms_data );
}

// -- callback -----
Main.callback_table.decide_output_file_path = function ( converter ) {
  local tmp = converter.get_translated_template_path();
  if ( converter.parameter.remove_can_not_use_character_as_file_path ) {
    tmp = BMX2WAV.Path.remove_can_not_use_character_as_file_path_from( tmp );
  }
  if ( converter.parameter.never_overwrite_output_file ) {
    tmp = BMX2WAV.Path.get_not_exist_path_from( tmp );
  }
  return tmp;
}


Main.callback_table.after_process = function ( converter ) {
  if ( converter.parameter.execute_after_process ) {
    BMX2WAV.create_process(
      converter.parameter.after_process_execute_file,
      BMX2WAV.replace_string( converter.parameter.after_process_execute_arguments, "@@output_file_path@@", converter.output_file_path ),
      BMX2WAV.Path.dirname( converter.parameter.after_process_execute_file ),
      converter.parameter.after_process_start_on_background ? BMX2WAV.ShowState.SHOW_MINIMIZED_NO_ACTIVE : BMX2WAV.ShowState.SHOW,
      converter.parameter.after_process_wait_for_process_exit );
  }
  if ( converter.parameter.after_process_delete_output_file ) {
    // remove() is squirrel system function
    ::remove( converter.output_file_path );
  }
}
